//Project: WinchBot 2.0
//Homepage: www.HomoFaciens.de
//Author Norbert Heinz
//Version: 0.1
//Creation date: 03.06.2017
//
//compile with gcc WinchBot2.c -o WinchBot2 -I/usr/local/include -L/usr/local/lib -lwiringPi -lm -lpigpio -pthread -Wall
//For details see:
//http://www.HomoFaciens.de/technics-machines-winchbot2_en_navion.htm

#include <stdio.h>
#include <termios.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/time.h>
#include <dirent.h>
#include <math.h>
#include <wiringPi.h>
#include <unistd.h>

#include <pigpio.h>
#include <signal.h>



//Base length of triangle in mm
#define BASELENGTH          895.0
//Initial cord length in mm
#define INITIAL_LENGTH       600.0
//Distance mount point cords to center of ball bearing mount at triangle
#define INITIAL_BAR_LENGTH   373.0
//Mount point cords on square tube
#define RADIUS_CORD_MOUNT     23.0
//Height from pivot point servo 4 to gripper
#define LEVER_S5 50.0
//Horizontal distance from pivot point servo 4 to tip of gripper
#define GRIPPER_LENGTH 60.0
//Horizontal offset from pivot point Servo 3 to centerline gripper
#define GRIPPER_OFFSET  5.0

//Time between two steps of platform motors
#define P_PAUSE 20000

//Time between two steps of WinchBot
#define STEP_PAUSE 500
//Pause needed for high signal on step input of motor driver
#define STEP_COMMAND_PAUSE 5

#define PI 3.1415927

//200 steps per turn, 7 teeth to 70 teeth
#define STEPS_PER_ANGLE  5.55555556

//Pin numbers WiringPi
#define M1_DIR          24            //Direction output motor
#define M1_STEP         25            //PWM output motor
#define M2_DIR          30            //Direction output motor
#define M2_STEP         21            //PWM output motor
#define M3_DIR          22            //Direction output motor
#define M3_STEP         23            //PWM output motor


#define ENABLE_MOTORS   26            //Motors disabled if pin LOW


#define MOTOR_P1_A   15
#define MOTOR_P1_B   16
#define MOTOR_P1_C    1
#define MOTOR_P1_D    4

#define MOTOR_P2_A   13
#define MOTOR_P2_B   14
#define MOTOR_P2_C   12
#define MOTOR_P2_D    3


//Pin numbers pigpio !!!

#define SERVO_3  16            //Servo arm rotate
#define SERVO_4  17            //Servo arm tilt
#define SERVO_5  27            //Servo gripper


#define SERVO_3_MIN  0
#define SERVO_3_MAX  180

#define SERVO_4_MIN  0
#define SERVO_4_MAX  180

#define SERVO_5_MIN  0
#define SERVO_5_MAX  180


int run = 1;
//12 teeth 80 teeth 2000 steps per revolution diameter drum 51.5mm
double StepsPermm = 13333.3 / 162.0;

double length1, length2, length3;


int Servo3 = 90;
int Servo4 = 90;
int Servo5 = 90;

#define SERVO_3_OFFSET  -30
#define SERVO_4_OFFSET  30
#define SERVO_5_OFFSET  0

long currentX = 0, currentY = 0, currentZ = 0;

double M1X, M1Y, M1Z;
double M2X, M2Y, M2Z;
double M3X, M3Y, M3Z;

int MotorP1Step = 0;
int MotorP2Step = 0;
double AngleP1 = 0.0;
double AngleP2 = 0.0;





//######################################################################
//################## Main ##############################################
//######################################################################

int main(int argc, char **argv){
int i;

  if (wiringPiSetup () == -1){
    printf("Could not run wiringPiSetup!");
    exit(1);
  }

  if (gpioInitialise() < 0){
    printf("Could not run gpioInitialise!");
    exit(1);
  }


  pinMode (5, OUTPUT);
  pinMode (6, OUTPUT);
  pinMode (10, OUTPUT);

for(i=0;i<10;i++){
digitalWrite(5, 1);
digitalWrite(6, 1);
digitalWrite(10, 1);
sleep(1);
digitalWrite(5, 0);
digitalWrite(6, 0);
digitalWrite(10, 0);
sleep(1);
}

  return 0;
}



